<?php
/*
	Program		: gamma.php
	Description	: Examines the requesting browser's user agent string and attempts
				  and issues an HTTP redirect to an image with the proper gamma
				  for the target operating system.
	Home page	: http://photondetector.com/tools_ref/gammadirector/
	Version		: 1.0 (15 Jan 2006)
	Author		: Nicolai Grossman <nicolai@photondetector.com>
	Tab stops	: 4

	Copyright (c) 2006 Nicolai Grossman

	This program is free software; you can redistribute them and/or modify
	them under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or (at
	your option) any later version.
	
	This program are distributed in the hope that they will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
	Public License for more details.
	( http://www.gnu.org/copyleft/gpl.html#SEC1 )
*/

	// Bail with a 404 if we didn't get an image name
	if(! $_REQUEST['img']) {
		header("HTTP/1.0 404 Not Found");
		echo "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">";
		echo "<html><head><title>404 Not Found</title></head><body>";
		echo "<h1>Not Found</h1><p>Missing img parameter, unable to fulfill request.</p></body></html>";
		exit;
	}

	// Are we on a secure connection? Stay in whatever mode we're in.
	// Stay on the port we're on w/o crapping up the URL unless we're non-standard.
	$port = "";

	if($_SERVER['HTTPS']) {
		$protocol = "https://";

		if($_SERVER['SERVER_PORT'] != 443) {
			$port = ":" . $_SERVER['HTTP_PORT'];
		}
	} else {
		$protocol = "http://";

		if($_SERVER['SERVER_PORT'] != 80) {
			$port = ":" . $_SERVER['HTTP_PORT'];
		}
	}

	$host = $_SERVER['HTTP_HOST'];
	$dir = dirname($_SERVER['PHP_SELF']);

	// Separate file name and extension
	// Regex lifted from http://www.faqts.com/knowledge_base/view.phtml/aid/6380/fid/7
	// A little weird, but the net effect works.
	//
	// Don't bother trying to filter directories. Since we're only redirecting,
	// we can let whatever access controls that may be in place in the subsequent
	// request handle that.
	$extension = ereg_replace("^.+\\.([^.]+)$", "\\1", $_REQUEST['img']);
	$file = rtrim($_REQUEST['img'], ".$extension");

	// If we don't have the pieces we need, redirect to whatever was passed
	if($file == "" || $extension == "") {
		header("Location: $protocol$host$port$dir/" . $_REQUEST['img']);
		exit;
	}

	// If we have a user agent and it's a Mac, set gamma to 1.8, otherwise to 2.2
	if(ereg("Mac", $_SERVER['HTTP_USER_AGENT'])) {
		$gamma = "1.8";
	} else {
		$gamma = "2.2";
	}

	// Send HTTP redirect to the appropriate image file
	header("Location: $protocol$host$port$dir/$file-$gamma.$extension");
?>